#!/usr/bin/env python

import sys, getopt, time, pyosd, os
import pygtk,wnck
import pyatspi
pygtk.require('2.0')
import gtk, gobject
import LtMacroAPI
from ctypes import *
import numpy


#              1,2,3,4,5,6,7   
assoc_buttons=[5,1,3,4,2,5,1]
assoc_direct =[0,0,1,0,0,0,1]


class extWin:
	def __init__(self):
		self.screen = wnck.screen_get_default()
		while gtk.events_pending():
			gtk.main_iteration()
		for window in self.screen.get_windows():
			if not window.get_name().startswith('A Tale'):
				continue
		self.gdkDisplay = gtk.gdk.Display(None)
		self.wnckWin = window
		self.xid    = window.get_xid()
		self.gdkWin = gtk.gdk.window_foreign_new(self.xid)
		self.init_osd()
		self.init_coreX()
		# Calculate the size of the whole screen
		self.screenw = gtk.gdk.screen_width()
		self.screenh = gtk.gdk.screen_height()

	def init_coreX(self):
		self.Xlib = CDLL("libX11.so.6")
		self.Xtst = CDLL("libXtst.so.6")
		self.dpy = self.Xtst.XOpenDisplay(None)
		self.Xlib.XFlush(self.dpy)

	def init_osd(self):
		self.osd = pyosd.osd()
		self.osd.set_font("-adobe-helvetica-bold-r-normal-*-*-100-*-*-p-*-*")
		self.osd.set_colour("lawngreen")
		self.osd.set_vertical_offset(48)
		self.osd.set_align(pyosd.ALIGN_RIGHT)
		
	def get_image(self,point,w=150,h=50):
		#def get_from_drawable(src, cmap, src_x, src_y, dest_x, dest_y, width, height)
		relativex, relativey, winw, winh, d = self.gdkWin.get_geometry()
		screenposx = max(0,point[0]-int(w/2))
		screenposy = max(0,point[1]-int(h/2))
		screenshot = gtk.gdk.Pixbuf.get_from_drawable(gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, True, 8, w, h),
            gtk.gdk.get_default_root_window(),
            gtk.gdk.colormap_get_system(),
            screenposx, screenposy, 0, 0, w, h)
		return screenshot

	def RGB_stats(self,im):
		pixels = im.get_pixels_array()
		p1 = numpy.average(pixels,1)
		stats = numpy.average(p1,0)
		return stats
		
	

	def beep(self):
		self.gdkDisplay.beep()
		self.gdkDisplay.sync()

	def focus(self):
		while gtk.events_pending():
			gtk.main_iteration()
		self.wnckWin.activate(gtk.get_current_event_time())
		self.gdkDisplay.sync()

	def osdlog(self,msg):
		self.osd.display(msg)
	
	# This will replace the LTool someday
	def get_coords(self):
		display = self.gdkWin.get_screen().get_display()
		cursor = gtk.gdk.Cursor(display, gtk.gdk.CROSSHAIR)
		#  gtk.gdk.pointer_grab(window, owner_events=False, event_mask=0, confine_to=None, cursor=None, time=0L)
		if (gtk.gdk.pointer_grab(self.gdkWin, False,
				gtk.gdk.BUTTON_RELEASE_MASK, None, cursor) == gtk.gdk.GRAB_SUCCESS):
			Clicked = False
			while Clicked == False:
				(screen,root_x,root_y,mods) = display.get_pointer()
				if mods & gtk.gdk.BUTTON1_MASK :
					Clicked = True
			gtk.gdk.pointer_ungrab()
			display.flush()
			(absX,absY) = self.gdkWin.get_origin()
			return (root_x, root_y, root_x-absX, root_y-absY)
		else:
			self.osdlog("Failed to grab mouse")
			return (0,0,0,0)

	def fake_key(self):
		#event = gtk.gdk.Event(gtk.gdk.KEY_PRESS)
		#event.keyval = gtk.keysyms.a
		#event.state = gtk.gdk.SHIFT_MASK
		#event.window = win.get_root_window()
		event.put()

	def send_string(self,s):
		for ch in s:
			keyval = gtk.gdk.unicode_to_keyval(ord(ch))
			pyatspi.Registry.generateKeyboardEvent(keyval, None, pyatspi.KEY_SYM)

class Base:
	def __init__(self):
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_decorated(False)
		self.window.set_title("Easy Crematory!")
		self.window.set_keep_above(True)
		color = gtk.gdk.color_parse('#234fdb')
		self.window.modify_bg(gtk.STATE_NORMAL, color)

		self.window.connect("destroy", self.destroy)
		self.Vbox1 = gtk.VBox(False, 0)
		self.box1 = gtk.HBox(False, 0)
		self.box2 = gtk.HBox(False, 0)
		self.window.add(self.Vbox1)
		
		i = 1
		self.buttons = []
		self.accel_group = gtk.AccelGroup()
		for assoc in assoc_buttons:
			print "Button :",i," assoc with ", assoc
			b = gtk.ToggleButton()
			dir = assoc_direct[i-1]
			# Find if button is press
			#root_hit =  hits_root[assoc-1]
			#img = atitd.get_image([root_hit[1],root_hit[2]],1,1)
			#stats = atitd.RGB_stats(img)
			#if (stats[0]<10):
			#	# Button is pressed
			#	b.set_active(True)
			#	
			id = b.connect("toggled", self.toggle_button_callback)
			b.set_active(True)
			self.box1.pack_start(b, True, True, 0)
			b.set_data("user_data", [id,assoc,dir])
			self.set_btn_image(b)
			b.show()
			i = i + 1
			self.buttons.append(b)
		self.box1.show()
		self.btn_quit=gtk.Button("Quit")
		self.btn_quit.connect("clicked",self.destroy,None)
		self.box2.pack_start(self.btn_quit, True, True, 0)
		self.btn_reset=gtk.Button("Fire")
		self.btn_reset.connect("clicked",self.reset_event,None)
		self.box2.pack_start(self.btn_reset, True, True, 0)
		self.window.set_app_paintable(True)
		self.box2.show()
		self.Vbox1.add(self.box1)
		self.Vbox1.add(self.box2)
		#self.window.add(self.Vbox1)
		self.Vbox1.show_all()
		self.window.show()
		
	
	def reset_event(self, widget, data=None):
		for b in self.buttons:
			b_id   =  b.get_data("user_data")[0]
			b.handler_block(b_id)
			b.set_active(True)
			self.set_btn_image(b)
			b.handler_unblock(b_id)
		atitd.osdlog("FIRE!!!")
		LtMacroAPI.clickwindow(target_fire_hit)
		return True
		
	def set_btn_image(self,button):
		b_data = button.get_data("user_data")[1]
		b_dir  = button.get_data("user_data")[2]
		if button.get_active():
			# button is pressed
			b_dir = not b_dir
		if b_dir:
			letter = "u"
		else:
			letter = "d" 
		image = gtk.Image()
		image.set_from_file("./gfx/go-"+letter+str(b_data)+".png")
		image.show()
		button.set_image(image)

	def toggle_button_callback(self,button):
		press_button  = button.get_data("user_data")[1]
		for b in self.buttons:
			b_data = b.get_data("user_data")[1]
			if b_data == press_button :
				b_id   =  b.get_data("user_data")[0]
				b.handler_block(b_id)
				b.set_active(button.get_active())
				self.set_btn_image(b)
				b.handler_unblock(b_id)
		atitd.osdlog("I press crematory button :"+str(press_button))	
		LtMacroAPI.clickwindow(hits[press_button-1])

	def main(self):
		gtk.main()

	def destroy(self, widget, data=None):
		print "destroy signal occurred"
		gtk.main_quit()

if __name__ == "__main__":
	# TODO : Move this inside class so no globals is ever used
	gtk.gdk.set_show_events(True)
	hits = []
	hits_root =[]
	atitd = extWin()
	atitd.focus()
	# Hopefully some day no ltool shit
	#point = atitd.get_coords()
	#img = atitd.get_image(point)
	
	#(target_hit, root_hit) = LtMacroAPI.getwindowclick()
	#img = atitd.get_image([root_hit[1],root_hit[2]])
	#pixels = img.get_pixels_array()
	#img.save("screenshot.png", "png",  {"quality": "20"})
	#os.system("display screenshot.png")
	
	print "Crematory made easy by Talos."
	atitd.osdlog("Crematory made easy by Talos.")
	print "------------------------------"
	print "* Click on crematory buttons now"
	for i in range(5):
		print "Get button :",str(i+1)
		atitd.osdlog("Get button :"+str(i+1))
		(target_hit, root_hit) = LtMacroAPI.getwindowclick()
		hits.append(target_hit)
		hits_root.append(root_hit)
		atitd.beep()
	atitd.osdlog("Show me the fire button")
	(target_fire_hit, root_fire_hit) = LtMacroAPI.getwindowclick()
	print "* Good. Now use Alt+mouse to move the new UI window"	
	atitd.osdlog("* Good. Now use Alt+mouse to move the new UI window")
	base = Base()
	base.main()
	atitd.osdlog("Thanks for using crematory tool!")

